import java.io.*;
import java.util.*;

public class fun_md implements Runnable {
	private Scanner in;
	private PrintWriter out;

	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void solve() throws IOException {
		Locale.setDefault(Locale.US);
		in = new Scanner(new FileReader("fun.in"));
		out = new PrintWriter("fun.out");
		int n = in.nextInt();
		int[] x = new int[n];
		int[] y = new int[n];
		for (int i = 0; i < n; i++) {
			x[i] = in.nextInt();
			y[i] = in.nextInt();
		}
		ArrayList<Integer> ans = null;
		for (int i = 0; i < n; i++) {
			HashSet<Integer> hs = new HashSet<Integer>();
			for (int j = 0; j < n; j++) if (i != j) {
				int h = (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]);
				hs.add(h);
			}
			if (i == 0) {
				ans = new ArrayList<Integer>(hs);
			} else {
				ArrayList<Integer> ans2 = new ArrayList<Integer>();
				for (int h : ans) {
					if (hs.contains(h)) {
						ans2.add(h);
					}
				}
				ans = ans2;
			}
		}
		Collections.sort(ans);
		out.println(ans.size());
		for (int h : ans) {
			out.println(Math.sqrt(h));
		}
		in.close();
		out.close();
	}

	public static void main(String[] args) {
		new Thread(new fun_md()).start();
	}
}
